library verilog;
use verilog.vl_types.all;
entity echo_block is
    generic(
        ADDR_SIZE       : integer := 14;
        IDLE            : integer := 0;
        WRITE_OUT       : integer := 1;
        WRITE_WAIT      : integer := 2;
        FINISH_WRITE    : integer := 3;
        READ_BEGIN      : integer := 4;
        FSL_WRITE       : integer := 5;
        FSL_WRITE_FINISH: integer := 6;
        FSL_WRITE_WAIT  : integer := 7;
        ADD_DATA        : integer := 8;
        ADD_DATA_WAIT   : integer := 9;
        RANDOM_WAIT     : integer := 10
    );
    port(
        clk             : in     vl_logic;
        Reset           : in     vl_logic;
        fsl_s_clk       : out    vl_logic;
        fsl_s_datain    : in     vl_logic_vector(15 downto 0);
        fsl_s_exists    : in     vl_logic;
        fsl_m_full      : in     vl_logic;
        fsl_s_read      : out    vl_logic;
        fsl_s_control   : in     vl_logic;
        fsl_m_clk       : out    vl_logic;
        fsl_m_dataout   : out    vl_logic_vector(15 downto 0);
        fsl_m_write     : out    vl_logic;
        fsl_m_control   : out    vl_logic
    );
end echo_block;
