-- W:\ECE532\IFFT_CORE\IFFT_CORE
-- VHDL Test Bench created by
-- HDL Bencher 6.1i
-- Mon Mar 21 10:07:17 2005
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
LIBRARY IEEE;
USE IEEE.NUMERIC_STD.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY test_ifft IS
END test_ifft;

ARCHITECTURE testbench_arch OF test_ifft IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT fsl_ifft
		GENERIC (
			C_DWIDTH : INTEGER
		);
		PORT (
			Clk : In  std_logic;
			Reset : In  std_logic;
			FSL_S_Clk : Out  std_logic;
			FSL_S_Read : Out  std_logic;
			FSL_S_Data : In  std_logic_vector (0 TO 31);
			FSL_S_Control : In  std_logic;
			FSL_S_Exists : In  std_logic;
			FSL_M_Clk : Out  std_logic;
			FSL_M_Write : Out  std_logic;
			FSL_M_Data : Out  std_logic_vector (0 TO 31);
			FSL_M_Control : Out  std_logic;
			FSL_M_Full : In  std_logic;
			Frame_Ready : In  std_logic
		);
	END COMPONENT;

	SIGNAL Clk : std_logic;
	SIGNAL Reset : std_logic;
	SIGNAL FSL_S_Clk : std_logic;
	SIGNAL FSL_S_Read : std_logic;
	SIGNAL FSL_S_Data : std_logic_vector (0 TO 31);
	SIGNAL FSL_S_Control : std_logic;
	SIGNAL FSL_S_Exists : std_logic;
	SIGNAL FSL_M_Clk : std_logic;
	SIGNAL FSL_M_Write : std_logic;
	SIGNAL FSL_M_Data : std_logic_vector (0 TO 31);
	SIGNAL FSL_M_Control : std_logic;
	SIGNAL FSL_M_Full : std_logic;
	SIGNAL Frame_Ready : std_logic;

BEGIN
	UUT : fsl_ifft
	GENERIC MAP (
		C_DWIDTH => 32
	)
	PORT MAP (
		Clk => Clk,
		Reset => Reset,
		FSL_S_Clk => FSL_S_Clk,
		FSL_S_Read => FSL_S_Read,
		FSL_S_Data => FSL_S_Data,
		FSL_S_Control => FSL_S_Control,
		FSL_S_Exists => FSL_S_Exists,
		FSL_M_Clk => FSL_M_Clk,
		FSL_M_Write => FSL_M_Write,
		FSL_M_Data => FSL_M_Data,
		FSL_M_Control => FSL_M_Control,
		FSL_M_Full => FSL_M_Full,
		Frame_Ready => Frame_Ready
	);

	PROCESS -- clock process for Clk,
	BEGIN
		CLOCK_LOOP : LOOP
		Clk <= transport '0';
		WAIT FOR 10 ns;
		Clk <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 40 ns;
		Clk <= transport '0';
		WAIT FOR 40 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS   -- Process for Clk
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_FSL_S_Clk(
			next_FSL_S_Clk : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (FSL_S_Clk /= next_FSL_S_Clk) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns FSL_S_Clk="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, FSL_S_Clk);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_FSL_S_Clk);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_FSL_S_Read(
			next_FSL_S_Read : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (FSL_S_Read /= next_FSL_S_Read) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns FSL_S_Read="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, FSL_S_Read);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_FSL_S_Read);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_FSL_M_Clk(
			next_FSL_M_Clk : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (FSL_M_Clk /= next_FSL_M_Clk) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns FSL_M_Clk="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, FSL_M_Clk);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_FSL_M_Clk);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_FSL_M_Write(
			next_FSL_M_Write : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (FSL_M_Write /= next_FSL_M_Write) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns FSL_M_Write="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, FSL_M_Write);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_FSL_M_Write);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_FSL_M_Data(
			next_FSL_M_Data : std_logic_vector (31 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (FSL_M_Data /= next_FSL_M_Data) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns FSL_M_Data="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, FSL_M_Data);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_FSL_M_Data);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_FSL_M_Control(
			next_FSL_M_Control : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (FSL_M_Control /= next_FSL_M_Control) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns FSL_M_Control="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, FSL_M_Control);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_FSL_M_Control);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		Reset <= transport '0';
		FSL_S_Data <= transport std_logic_vector'("00000000000000000000000000000000"); --0
		FSL_S_Control <= transport '0';
		FSL_S_Exists <= transport '0';
		FSL_M_Full <= transport '0';
		Frame_Ready <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=100 ns
		Reset <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=200 ns
		Reset <= transport '0';
		-- --------------------
        WAIT FOR 100 ns; -- Time=200 ns
		FSL_S_Exists <= transport '1';
		-- --------------------
		WAIT FOR 400 ns; -- Time=300 ns
		FSL_S_Data <= transport std_logic_vector'("00000100000000000000010000000000"); --1
        --FSL_S_Data <= transport std_logic_vector'("01111111111111110111111111111111");
		-- --------------------
        WAIT FOR 100 ns;
        FSL_S_Data <= transport std_logic_vector'("00000000000000000000000000000000"); --1
        -- --------------------
        WAIT FOR 200000 ns; -- Time=14600 ns
        FSL_S_Exists <= transport '0';
		-- --------------------
		WAIT FOR 120000 ns; -- Time=14600 ns
		-- --------------------

		WAIT FOR 100 ns; -- Time=300 ns
		FSL_S_Exists <= transport '1';
		-- --------------------
		WAIT FOR 400 ns; -- Time=300 ns
   		FSL_S_Data <= transport std_logic_vector'("01000000000000000100000000000000"); --1
        -- --------------------
        WAIT FOR 100 ns;
        FSL_S_Data <= transport std_logic_vector'("00000000000000000000000000000000"); --1
        -- --------------------
		WAIT FOR 400000 ns; -- Time=14600 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			STD.TEXTIO.write(TX_OUT,string'("No errors or warnings"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			STD.TEXTIO.write(TX_OUT, TX_ERROR);
			STD.TEXTIO.write(TX_OUT, string'(
				" errors found in simulation"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION fsl_ifft_cfg OF test_ifft IS
	FOR testbench_arch
	END FOR;
END fsl_ifft_cfg;
