#include "xparameters.h"
#include "xbasic_types.h"   /* Xilinx basic types for device drivers        */
#include "xac97.h"
#include "xac97_l.h"
#include "xac97_i.h"
#include "mb_interface.h"

#define TRUE 1
#define FALSE 0
#define printf xil_printf

#define BUF_LEN 512
#define HALF_BUF_LEN BUF_LEN >> 1

void FFT_Test(void);

int main (void) 
{
    int i;
    Xint16 nLeftChan;
    Xint16 nRightChan;
    Xint16 nData;
    Xint16 nInBuffer1[256];
    Xint16 nInBuffer2[256];
    Xint16 *pInNewData = nInBuffer1;
    Xint16 *pInOldData = nInBuffer2;
    Xint16 nOutBuffer1[256];
    Xint16 nOutBuffer2[256];
    Xint16 *pOutNewData = nOutBuffer1;
    Xint16 *pOutOldData = nOutBuffer2;
    Xint16 *pTemp;

    Xint16 nInBuffer[512];
    Xint32 nShift;
    Xint32 nFScale, nIScale;

    // start the AC97 controller
    init_sound (44100);

    playback_enable();
    record_enable();

    //FFT_Test();
    while (1) 
    {

        for (i = 0; i < BUF_LEN; i++) {
            microblaze_bread_datafsl(nLeftChan, 0);
            microblaze_bread_datafsl(nRightChan, 0);

            nData = nLeftChan;

            microblaze_bwrite_datafsl(nData, 1);
        }

        microblaze_bwrite_datafsl(0, 2);
        microblaze_bread_datafsl(nFScale, 2);
        microblaze_bread_datafsl(nIScale, 3);

        if ((nIScale + nFScale) > 9) {
            nShift = (nIScale + nFScale - 9);
            for (i = 0; i < BUF_LEN; i++) {
                microblaze_bread_datafsl(nData, 1);

                nLeftChan = nData << nShift;

                microblaze_bwrite_datafsl(nLeftChan, 0);
                microblaze_bwrite_datafsl(nLeftChan, 0);
            }
        }
        else {
            nShift = (9 - (nIScale + nFScale));
            for (i = 0; i < BUF_LEN; i++) {
                microblaze_bread_datafsl(nData, 1);

                nLeftChan = nData >> nShift;

                microblaze_bwrite_datafsl(nLeftChan, 0);
                microblaze_bwrite_datafsl(nLeftChan, 0);
            }
        }

        // Buffer in new samples
        /*for (i = 0; i < HALF_BUF_LEN; i++) {
            microblaze_bread_datafsl(pInNewData[i], 0);
            microblaze_bread_datafsl(nRightChan, 0);
        }

        // Take old samples and window
        for (i = 0; i < HALF_BUF_LEN; i++) {
            nData = (pInOldData[i] * (i + 1)) >> 8;
            microblaze_bwrite_datafsl(nData, 1);
        }
        // Take new samples and window
        for (i = 0; i < HALF_BUF_LEN; i++) {
            nData = (pInNewData[i] * (256 - i)) >> 8;
            microblaze_bwrite_datafsl(nData, 1);
        }
        // Swap new old input buffers;
        pTemp = pInNewData;
        pInNewData = pInOldData;
        pInOldData = pTemp;

        // start FFT processing
        microblaze_bwrite_datafsl(0, 2);

        microblaze_bread_datafsl(nFScale, 2);
        microblaze_bread_datafsl(nIScale, 3);

        if ((nIScale + nFScale) > 9) {
            nShift = (nIScale + nFScale - 9);
                // Write out processed data
                for (i = 0; i < HALF_BUF_LEN; i++) {
                	microblaze_bread_datafsl(pOutNewData[i], 1);
					pOutNewData[i] = pOutNewData[i] << nShift;
        		}
        		// Add with old samples and output
        		for (i = 0; i < HALF_BUF_LEN; i++) {
            		nLeftChan = (pOutNewData[i] + pOutOldData[i]);
            		// write out
            		microblaze_bwrite_datafsl(nLeftChan, 0);
            		microblaze_bwrite_datafsl(nLeftChan, 0);
        		}
        		// read in samples to overlap and add for next time
        		for (i = 0; i < HALF_BUF_LEN; i++) {
            		microblaze_bread_datafsl(pOutOldData[i], 1);
					pOutOldData[i] = pOutOldData[i] << nShift;
        		}
        }
        else {
            nShift = (9 - (nIScale + nFScale));
                // Write out processed data
                for (i = 0; i < HALF_BUF_LEN; i++) {
                	microblaze_bread_datafsl(pOutNewData[i], 1);
					pOutNewData[i] = pOutNewData[i] >> nShift;
        		}
        		// Add with old samples and output
        		for (i = 0; i < HALF_BUF_LEN; i++) {
            		nLeftChan = (pOutNewData[i] + pOutOldData[i]);
            		// write out
            		microblaze_bwrite_datafsl(nLeftChan, 0);
            		microblaze_bwrite_datafsl(nLeftChan, 0);
        		}
        		// read in samples to overlap and add for next time
        		for (i = 0; i < HALF_BUF_LEN; i++) {
            		microblaze_bread_datafsl(pOutOldData[i], 1);
					pOutOldData[i] = pOutOldData[i] >> nShift;
        		}
            }*/

    }

}

/*void FFT_Test(void) {

    int i;
    Xint16 nInBuffer[512];
    Xint16 nOutBuffer[512];
    Xuint8 nFScale;
    Xuint8 nIScale;

    for (i = 0; i < BUF_LEN; i++) {
        if (i % 2 == 0)
            nInBuffer[i] = 32767;
        else
            nInBuffer[i] = -32767;
    }

    //nInBuffer[0] = 5;

    for (i = 0; i < BUF_LEN; i++) {
        microblaze_bwrite_datafsl(nInBuffer[i], 0);
    }

    // start the FFT
    microblaze_bwrite_datafsl(0, 2);

    for (i = 0; i < BUF_LEN; i++) {
        microblaze_bread_datafsl(nOutBuffer[i], 0);
        //printf("Got to %d\r\n", i);
    }
    //microblaze_bread_datafsl(nFScale, 2);

    for (i = 0; i < BUF_LEN; i++) {
        microblaze_bwrite_datafsl(nOutBuffer[i], 1);
        //printf("Got to %d\r\n", i);
    }

    // start the IFFT
    microblaze_bwrite_datafsl(0, 3);

    for (i = 0; i < BUF_LEN; i++) {
        microblaze_bread_datafsl(nInBuffer[i], 1);
        //printf("Got to %d\r\n", i);
    }
    // Get scale factor
    microblaze_bread_datafsl(nIScale, 3);

    for (i = 0; i < BUF_LEN; i++) {
        printf("Result is %d\r\n", nOutBuffer[i]);
    }
}*/