#include "xparameters.h"
#include "xbasic_types.h"   /* Xilinx basic types for device drivers        */
#include "xac97.h"
#include "xac97_l.h"
#include "xac97_i.h"
#include "mb_interface.h"
#include "xparameters.h"
#include "xuartlite.h"

#define TRUE 1
#define FALSE 0
#define printf xil_printf

XUartLite Uart;
Xint8 currFreq[10];
Xint8 currGain[5];
Xint8 currFreqIndex;
Xint8 currGainIndex;
Xint8 gains[10];

void printDisplay(int freq,int gainSelect);

int main (void)
{
    XStatus Status;
    unsigned int nRecvBytes, nSendBytes;
    Xuint8 nBuffer;
	int i=0;
	// start the AC97 controller
    init_sound (22050);
    playback_enable();
    record_enable();

        currFreqIndex = 0;
        currFreq[0] = ' ';

        currGain[0] = ' ';
        currGain[1] = ' ';
        currGain[2] = '>';
        currGain[3] = ' ';
        currGain[4] = ' ';

        // Initialize Freq Select characters
        for (i=1; i < 10; i++)
                currFreq[i]=' ';

    /************************* UART Setup ********************************/
    /* initialize the uart */
    Status = XUartLite_Initialize(&Uart, XPAR_RS232_DEVICE_ID);
    if (Status != XST_SUCCESS)
    {
        printf("UART initialization error\n\r");
    }
    /* reset FIFOs */
    XUartLite_ResetFifos(&Uart);
    /* do a self test, seems to fail, not good? */
    Status = XUartLite_SelfTest(&Uart);
    if (Status != XST_SUCCESS)
    {
        printf("UART self test failed\n\r");
    }

    while (1)
    {
        nRecvBytes = XUartLite_Recv(&Uart, &nBuffer, 1);
        if (nRecvBytes > 0)
	    {
            if (nBuffer == 106)
                    printDisplay(-1,0);
            if (nBuffer == 108)
                    printDisplay(1,0);
            if (nBuffer == 105)
                    printDisplay(0,-1);
            if (nBuffer == 107)
                    printDisplay(0,1);
    }
	}
    return 0;
}

void printDisplay(int freq,int gainSelect)
{
        if (freq !=0)
        {
                currFreq[currFreqIndex] = ' ';
                currFreqIndex = currFreqIndex + freq;
                if (currFreqIndex < 0)
                        currFreqIndex = 0;
                if (currFreqIndex > 9)
                        currFreqIndex = 9;
                currFreq[currFreqIndex] = '*';
        }
        if (gainSelect !=0)
        {
                currGain[currGainIndex] = ' ';
                currGainIndex = currGainIndex + gainSelect;
                if (currGainIndex < 0)
                        currGainIndex = 0;
                if (currGainIndex > 4)
                        currGainIndex = 4;
                currGain[currGainIndex] = '>';
        }

        printf("\n\r\n\r\n\r\n\r\n\r         Graphical Equalizer\n\r\n\r\n\r\n\r\n\r");

        printf("  %c  4    4    4    4    4    4    4    4    4    4\n\r",
                currGain[0]);
        printf("  %c  2    2    2    2    2    2    2    2    2    2\n\r",
                currGain[1]);
        printf("  %c  1    1    1    1    1    1    1    1    1    1\n\r",
                currGain[2]);
        printf("  %c  1/2  1/2  1/2  1/2  1/2  1/2  1/2  1/2  1/2  1/2\n\r",
                currGain[3]);
        printf("  %c  1/4  1/4  1/4  1/4  1/4  1/4  1/4  1/4  1/4  1/4\n\r\n\r",
                currGain[4]);
        printf("     86  172   258  345  517  1034 1981 3962 8010 16021 (Hz)\n\r");
        printf("     %c    %c    %c    %c    %c    %c    %c    %c    %c    %c \n\r",
                currFreq[0], currFreq[1], currFreq[2], currFreq[3], currFreq[4],
                currFreq[5], currFreq[6], currFreq[7], currFreq[8], currFreq[9]);


}
